<template>
  <v-container style="height: 100%">
    <v-row style="height: 100%">
      <v-col
        cols="12"
        sm="3"
      />

      <v-col
        cols="12"
        sm="6"
        class="d-flex"
      >
        <v-card
          class="mx-auto my-auto"
          outlined
          max-width="450"
        >
          <v-form
            class="py-10 px-5"
            @submit.prevent="handleClickRegister"
          >
            <v-list-item three-line>
              <v-list-item-content>
                <div class="d-flex justify-center">
                  <v-img
                    :src="require('@/assets/images/svg/login.svg')"
                    max-width="100"
                  />
                </div>

                <div class="overline text-center">
                  LNU
                </div>
                <v-list-item-title class="headline mb-2 text-center">
                  Register
                </v-list-item-title>
                <v-list-item-subtitle class="text-center">
                  to continue to <b>{{ $env.title }}</b>
                </v-list-item-subtitle>
              </v-list-item-content>
              <!--
              <v-list-item-avatar
                tile
                size="80"
              >

              </v-list-item-avatar> -->
            </v-list-item>

            <v-divider class="my-5" />

            <v-container>
              <v-row dense>
                <v-col cols="12">
                  <v-text-field
                    v-model="registerForm.fname"
                    rounded
                    autocomplete="off"
                    outlined
                    label="First name"
                    hide-details
                    required
                  />
                </v-col>

                <v-col cols="12">
                  <v-text-field
                    v-model="registerForm.mname"
                    rounded
                    autocomplete="off"
                    outlined
                    label="Middle Intial"
                    hide-details
                    required
                  />
                </v-col>

                <v-col cols="12">
                  <v-text-field
                    v-model="registerForm.lname"
                    rounded
                    autocomplete="off"
                    outlined
                    label="Last name"
                    hide-details
                    required
                  />
                </v-col>

                <v-col cols="12">
                  <v-text-field
                    v-model="registerForm.username"
                    rounded
                    autocomplete="off"
                    outlined
                    label="Username"
                    hide-details
                    required
                  />
                </v-col>

                <v-col cols="12">
                  <v-text-field
                    v-model="registerForm.password"
                    rounded
                    autocomplete="off"
                    type="password"
                    outlined
                    label="Password"
                    hide-details
                    required
                  />
                </v-col>

                <v-col cols="12">
                  <v-btn
                    color="primary"
                    elevation="0"
                    type="submit"
                    block
                    rounded
                    x-large
                  >
                    Register
                  </v-btn>
                </v-col>
              </v-row>
            </v-container>
          </v-form>
        </v-card>
      </v-col>

      <v-col
        cols="12"
        sm="3"
      />
    </v-row>
  </v-container>
</template>

<script>
// eslint-disable-next-line no-unused-vars
import { mapActions, mapGetters, mapState, mapMutations } from 'vuex'

import _get from 'lodash/get'

export default {
  name: 'Register',

  data: () => ({
    registerForm: {
      fname: undefined,
      mname: undefined,
      lname: undefined,
      username: undefined,
      password: undefined,
      reset () {
        this.fname = undefined
        this.mname = undefined
        this.lname = undefined
        this.username = undefined
        this.password = undefined
      }
    }
  }),

  created () {
    window.localStorage.clear()

    this.setStateUser({
      state: 'authUser',
      value: null
    })
  },

  methods: {
    ...mapActions('auth', {
      getLoginToken: 'getLoginToken'
    }),

    ...mapActions('users', {
      getAuthUser: 'getAuthUser',
      registerUser: 'register'
    }),

    ...mapMutations('users', {
      setStateUser: 'SET_STATE'
    }),

    async handleClickRegister (e) {
      try {
        await this.registerUser(this.registerForm)

        this.$setAlert({ type: 'success', text: 'Your registration request has been send and is waiting for confirmation' })

        this.registerForm.reset()

        return this.$router.push({ name: 'Login' })
      } catch (error) {
        this.$localStorage.remove('token')
        const text = _get(error, 'response.data.message')
        this.$setAlert({ type: 'error', text })
      }
    }
  }
}
</script>
